public enum EAPcode { 
	EAP_CODE_ZERO(0),
	EAP_CODE_REQUEST(1),
	EAP_CODE_RESPONSE(2),
	EAP_CODE_SUCCESS(3),
	EAP_CODE_FAILURE(4),
	EAP_CODE_TEST(12),
	EAP_CODE_UNKNOWN(255);
	
	public byte type;
	
	private EAPcode(int type) {
		this.type = (byte)type;
	}
	
	private EAPcode(byte type) {
		this.type = type;
	}
	
	public byte getValue() {
		return type;
	}
	
	public static EAPcode valueOf(byte tp) {
		switch (tp) {
		case 0: return EAP_CODE_ZERO;
		case 1: return EAP_CODE_REQUEST;
		case 2:	return EAP_CODE_RESPONSE;
		case 3:	return EAP_CODE_SUCCESS;
		case 4:	return EAP_CODE_FAILURE;
		case 12: return EAP_CODE_TEST;
		default: return EAP_CODE_UNKNOWN;
		}
	}
}