// EAP packet

public class EAPheader extends BasicPayloadObject {
	public EAPcode  code;
	public byte  identifier;
	public short length;               // 2 bytes
	public byte[] pldData = null; 
	protected boolean isLengthSet = false;


	public int getSize() {
		if(pldData != null) 
			return 4 + pldData.length;
		else
			return 4;
	}

	public void setLength() {
		length = (short)getSize();
		isLengthSet = true;
	}

	public void setLength(int len) {
		length = (short)len;
		isLengthSet = true;
	}

	public int parseNetMessage() {
		int res = 0;
		byte[] data = this.net_msg;
		if(data == null) 
			res = 1;
		else if(data.length < 4) 
			res = 2;
		else {
			this.code = EAPcode.valueOf(data[0]);
			this.identifier = data[1];
			this.length = (short)(data[2] & 0xFF);
			this.length <<= 8;
			this.length |= (data[3] & 0xFF);
			
			if(data.length > 4) {
				this.pldData = new byte[data.length - 4];
				System.arraycopy(data, 4, this.pldData, 0, data.length - 4);
			}
		}
		
		return res;
	}

	public int toByteArray() {
		int i = 0;
		if(isLengthSet == false) setLength();
		// create byte array
		byte[] ba = new byte[getSize()];
		
		ba[i++] = code.getValue();
		ba[i++] = identifier;
		ba[i++] = (byte)(length >>> 8);
		ba[i++] = (byte)length;
		if(pldData != null) {
			System.arraycopy(pldData, 0, ba, i, pldData.length);
		}
		net_msg = ba;
		return 0;
	}

	public void print(String pref) {
		DebugInfo.printMessage(1,pref + "EAP packet:");
		DebugInfo.printMessage(1,pref + "  code: " + this.code);
		DebugInfo.printMessage(1,pref + "  identifier: " + this.identifier);
		DebugInfo.printMessage(1,pref + "  length: " + this.length);
		DebugInfo.printDump(1, this.pldData, pref + "  data:");
	}

	public void print() {
		this.print("");
	}
}