import java.security.MessageDigest;


public class EAPtypePldMd5 extends BasicPayloadObject {    
	public int  valueSize;
	public byte[] value = null; 
	public byte[] name = null; 
	protected boolean isLengthSet = false;


	public int getSize() {
                int i=1;
		if(value != null) 
			i += value.length;
		if(name != null) 
			i += name.length;
		return i;
	}

	public void setLength() {
		if(value != null) 
			valueSize = value.length;
		else
			valueSize = 0;
		isLengthSet = true;
	}

	public void setLength(int len) {
		valueSize = len;
		isLengthSet = true;
	}

// a stream of octets consisting of the Identifier, followed by (concatenated with) the "secret", followed by (concatenated with) the Challenge Value (RFC 1994)
	public int setMD5value(byte id, byte[] chlg_value, byte[] key) throws Exception {
		MessageDigest mobj;
		byte[] data = null;
		int res = 0;
		
		if((chlg_value == null) || (key == null)) {
			res = 1;
			DebugInfo.printMessage(3,"EAPtypePldMd5::setMD5value: null pointer");
		}

		data = new byte[1 + chlg_value.length + key.length];
		data[0] = id;

		System.arraycopy(key, 0, data, 1, key.length);
		System.arraycopy(chlg_value, 0, data, 1 + key.length, chlg_value.length);
		DebugInfo.printDump(3, data, "EAPtypePldMd5::setMD5value: input data");

		mobj = MessageDigest.getInstance("MD5");
		value = mobj.digest(data);
		valueSize = value.length;
		DebugInfo.printDump(3, value, "EAPtypePldMd5::setMD5value: MD5 hash");

		return res;
	}

	public int parseNetMessage() {
		int res = 0;
		byte[] data = this.net_msg;
		if(data == null) 
			res = 1;
		else if(data.length < 1) 
			res = 2;
		else {
			this.valueSize = data[0];
			int len = 0;
			
			if(data.length > 1) {
				if(valueSize > 0) {
					len = data.length > valueSize ? valueSize : data.length - 1;
					this.value = new byte[len];
					System.arraycopy(this.net_msg, 1, this.value, 0, len);
				}
				len++;
				if (data.length > len) {
					this.name = new byte[data.length - len];
					System.arraycopy(data, len, this.name, 0, this.name.length);
				}
			}
		}
		
		return res;
	}

	public int toByteArray() {
		int i = 0;
		if(isLengthSet == false) setLength();
		// create byte array
		byte[] ba = new byte[getSize()];
		
		ba[i++] = (byte)valueSize;
		if(value != null) {
			System.arraycopy(value, 0, ba, i, value.length);
		}
		if(name != null) {
			System.arraycopy(name, 0, ba, i, name.length);
		}
		net_msg = ba;
		return 0;
	}

	public void print(String pref) {
		DebugInfo.printMessage(1,pref + "EAP Md5 payload:");
		DebugInfo.printMessage(1,pref + "  valueSize: " + this.valueSize);
		DebugInfo.printDump(1, this.value, pref + "  value:");
		DebugInfo.printDump(1, this.name, pref + "  name:");
	}
}