import java.io.*;
import java.math.BigInteger;
import java.net.*;
import java.util.ArrayList;
import java.security.*;

import javax.crypto.interfaces.DHPublicKey;



public class tryEAPinit
{
	// for messages that don't belong to any IKE_SA
	public ArrayList request_list_noSA;
	public ArrayList response_list_noSA;
	// messages received from NUT
	public ArrayList received_messages_list;
	public static int MTN_ike2_window_size;
	public static int destination_port = 1812; 

	public static byte[] sendData = new byte[65000];
	public static int sendDataLength = 0;
	public static byte[] receiveData = new byte[65000];
	public static int receiveDataLength = 0;

	public static InetAddress remoteIPAddress;
//	public static String remoteHost = "192.168.56.101";
	public static byte[] remoteHostRaw = {(byte)(192),(byte)(168),(byte)(56),(byte)(101)};
	public static byte[] localHostRaw = {(byte)(192),(byte)(168),(byte)(160),(byte)(1)};

    /*
	struct model_in6_addr *ob42, *fb62;
	struct model_in4_addr *ob42_4, *fb62_4, *lin_4;
	uint8_t ob42_addr[16] = {0x20,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x42};
	uint8_t fb62_addr[16] = {0x20,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x62};
	uint8_t ob42_4_addr[4] = {192,168,110,42};
	uint8_t fb62_4_addr[4] = {192,168,110,62};
	uint8_t lin_4_addr[4] = {192,168,110,2};

	char key1[16] = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16};
	char key2[20] = {20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1};
	char key3[24] = {24,23,22,21,20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1};

#define MESSAGE_DATA "Hello, World!"
#define key_str_128b "1234567812345678"
#define iv_str_128b  "0000000000000000"
#define key_str_160b "12345678123456781234"
#define iv_str_160b  "00000000000000000000"
#define key_str_64b  "12345678"
#define iv_str_64b   "00000000"
#define key_str_192b "123456781234567812345678"
#define iv_str_192b  "000000000000000000000000"
#define dh_grp_2  "23151515636457458548569870976845763475463474676574587585787698798760896980879576465235653476742543525436547657346523564363565325"
		byte[] dh_grp_2 = {2,3,1,5,1,5,1,5,6,3,6,4,5,7,4,5,8,5,4,8,5,6,9,8,7,0,9,7,6,8,4,5,7,6,3,4,7,5,4,6,3,4,7,4,6,7,6,5,7,4,5,8,7,5,8,5,7,8,7,6,9,8,7,9,8,7,6,0,8,9,6,9,8,0,8,7,9,5,7,6,4,6,5,2,3,5,6,5,3,4,7,6,7,4,2,5,4,3,5,2,5,4,3,6,5,4,7,6,5,7,3,4,6,5,2,3,5,6,4,3,6,3,5,6,5,3,2,5};

#define _SPI  1234
#define _SEQUENCENUMBER  0x00000001
 

*/
	
	public static void main(String args[]) throws Exception {
		DebugInfo.debugLevel = 2;
		DebugInfo.maxDumpSize = 1000;

		DatagramSocket clientSocket = new DatagramSocket();
		clientSocket.setSoTimeout(2000);
//		remoteIPAddress = InetAddress.getByName(remoteHost);
		remoteIPAddress = InetAddress.getByAddress(remoteHostRaw);
		DatagramPacket sendPacket;
		DatagramPacket receivePacket = new DatagramPacket(receiveData, receiveData.length);

		String SharedSecretStr = "testing123";
		byte[] SharedSecret = SharedSecretStr.getBytes();
		String UserPwdStr = "123456";
		byte[] UserPwd = UserPwdStr.getBytes();
		byte[] ReqAuth1 = {(byte)0x04,(byte)0x82,(byte)0x9f,(byte)0x5e,(byte)0xe2,(byte)0xa4,(byte)0x65,(byte)0xa7,(byte)0x6c,(byte)0x9b,(byte)0xd9,(byte)0xf3,(byte)0x41,(byte)0x60,(byte)0xd4,(byte)0xc6};
		byte[] ReqAuth2 = {(byte)0x5a,(byte)0x30,(byte)0x7e,(byte)0x5b,(byte)0x40,(byte)0xec,(byte)0xc3,(byte)0x95,(byte)0xcc,(byte)0x69,(byte)0x05,(byte)0x41,(byte)0x67,(byte)0xa8,(byte)0x00,(byte)0x13}; 

// send first message		
		DebugInfo.printMessage(1,"try create pkt1");
		
		EAPRadiusHeader	radPkt = new EAPRadiusHeader(1,90);
	
	    EAPRadiusAttributes radAttr_name = new EAPRadiusAttributes(1);
		String userName = "sqltest";
		radAttr_name.value = userName.getBytes();

	    EAPRadiusAttributes radAttr_pwd = new EAPRadiusAttributes(2);
		radAttr_pwd.setUserPassword(UserPwd, SharedSecret, radPkt.authenticator);

		byte[] nasHostRaw = {(byte)(127),(byte)(0),(byte)(1),(byte)(1)};
	    EAPRadiusAttributes radAttr_ip = new EAPRadiusAttributes(4,nasHostRaw);

		byte[] nasPortRaw = {(byte)(0),(byte)(0),(byte)(7),(byte)(20)};
	    EAPRadiusAttributes radAttr_port = new EAPRadiusAttributes(5,nasPortRaw);

		EAPRadiusAttributes radAttr_eap_start = new EAPRadiusAttributes(79);

		byte[] EapRaw = {(byte)0x02,(byte)0x5a,(byte)0x00,(byte)0x0c,(byte)0x01,(byte)0x73,(byte)0x71,(byte)0x6c,(byte)0x74,(byte)0x65,(byte)0x73,(byte)0x74};
		EAPRadiusAttributes radAttr_eap = new EAPRadiusAttributes(79,EapRaw);

	    EAPRadiusAttributes radAttr_auth = new EAPRadiusAttributes(80);
	    
	    int res1;
/*
        radPkt.addAttribute(radAttr_name);
        radPkt.addAttribute(radAttr_pwd);
        radPkt.addAttribute(radAttr_ip);
        radPkt.addAttribute(radAttr_port);
        radPkt.addAttribute(radAttr_eap);
        radPkt.addAttribute(radAttr_auth);

		radAttr_auth.setMessageAuthenticator(radPkt,SharedSecret);
		radPkt.toByteArray();

		DebugInfo.printDump(1, radPkt.net_msg, "Radius packet");
		DebugInfo.printMessage(1,"Sending Radius packet");

		sendPacket = new DatagramPacket(radPkt.net_msg, radPkt.net_msg.length, remoteIPAddress, destination_port);
		clientSocket.send(sendPacket);

		DebugInfo.printMessage(1,"packet has been sended");


// parse received message		
		clientSocket.receive(receivePacket);
		DebugInfo.printMessage(1,"packet has been received, length: " + receivePacket.getLength());
		DebugInfo.printDump(2, receivePacket.getData(), 0, receivePacket.getLength() , "recvpkt");

		EAPRadiusHeader	radPktRecv = new EAPRadiusHeader();
		radPktRecv.net_msg = new byte[receivePacket.getLength()];
		System.arraycopy(receivePacket.getData(), 0, radPktRecv.net_msg, 0, receivePacket.getLength());
		res1 = radPktRecv.parseNetMessage();
		DebugInfo.printMessage(1,"packet was parsed, res: " + res1);
		radPktRecv.print();


// parse EAP received message
		EAPheader eapRecv = null;
		EAPRadiusAttributes eapRadiusRecv = radPktRecv.getAttributeByType(79);
		if((eapRadiusRecv != null) && (eapRadiusRecv.value != null)) {
			if(eapRadiusRecv.value.length > 4)
				eapRecv = new EAPpldBasic();
			else
				eapRecv = new EAPheader();
			
			System.arraycopy(eapRadiusRecv.value, 0, eapRecv.net_msg, 0, eapRadiusRecv.value.length);
			res1 = eapRecv.parseNetMessage(); 
			DebugInfo.printMessage(1,"EAP packet was parsed, res: " + res1);
			eapRecv.print();
		}
*/
// send second message		
		radPkt = new EAPRadiusHeader(1,91);
//		radAttr_pwd.setUserPassword(UserPwd, SharedSecret, radPkt.authenticator);
        radPkt.addAttribute(radAttr_name);
//        radPkt.addAttribute(radAttr_pwd);
//        radPkt.addAttribute(radAttr_ip);
//        radPkt.addAttribute(radAttr_port);
        radPkt.addAttribute(radAttr_auth);
        radPkt.addAttribute(radAttr_eap);

		radAttr_auth.setMessageAuthenticator(radPkt,SharedSecret);
		radPkt.toByteArray();

		DebugInfo.printDump(1, radPkt.net_msg, "Radius packet");
		DebugInfo.printMessage(1,"Sending Radius packet");

		sendPacket = new DatagramPacket(radPkt.net_msg, radPkt.net_msg.length, remoteIPAddress, destination_port);
		clientSocket.send(sendPacket);

		DebugInfo.printMessage(1,"packet has been sended");


// parse received message		
		clientSocket.receive(receivePacket);
		DebugInfo.printMessage(1,"packet has been received, length: " + receivePacket.getLength());
		DebugInfo.printDump(2, receivePacket.getData(), 0, receivePacket.getLength() , "recvpkt");

		EAPRadiusHeader	radPktRecv2 = new EAPRadiusHeader();
		radPktRecv2.net_msg = new byte[receivePacket.getLength()];
		System.arraycopy(receivePacket.getData(), 0, radPktRecv2.net_msg, 0, receivePacket.getLength());
		res1 = radPktRecv2.parseNetMessage();
		DebugInfo.printMessage(1,"packet was parsed, res: " + res1);
		radPktRecv2.print();


// parse EAP received message
		EAPheader eapRecv2 = null;
		EAPRadiusAttributes eapRadiusRecv2 = radPktRecv2.getAttributeByType(79);
		if((eapRadiusRecv2 != null) && (eapRadiusRecv2.value != null)) {
			DebugInfo.printMessage(1,"EAP message found, try parse");
			eapRadiusRecv2.print("");
			if(eapRadiusRecv2.value.length > 4)
				eapRecv2 = new EAPpldBasic();
			else
				eapRecv2 = new EAPheader();
			
			eapRecv2.net_msg = new byte[eapRadiusRecv2.value.length];
			System.arraycopy(eapRadiusRecv2.value, 0, eapRecv2.net_msg, 0, eapRadiusRecv2.value.length);
			res1 = eapRecv2.parseNetMessage(); 
			DebugInfo.printMessage(1,"EAP packet was parsed, res: " + res1);
			eapRecv2.print();
		}
		
		
// send third message		
		DebugInfo.printMessage(1,"try create pkt3");

		radPkt = new EAPRadiusHeader(1,92);
		
		radAttr_pwd.setUserPassword(UserPwd, SharedSecret, radPkt.authenticator);

        EAPpldBasic eapMsg2 = new EAPpldBasic();
        eapMsg2.code = EAPcode.EAP_CODE_RESPONSE;
        eapMsg2.identifier = eapRecv2.identifier;
        eapMsg2.type = EAPtype.EAP_TYPE_MD5CHALLENGE;
        EAPtypePldMd5 eapPldMd5 = new EAPtypePldMd5();
        eapPldMd5.setMD5value(eapMsg2.identifier, ((EAPtypePldMd5)(((EAPpldBasic)eapRecv2).EAPmethodPld)).value, UserPwd);
        
        eapMsg2.EAPmethodPld = eapPldMd5;
        eapMsg2.toByteArray();
		EAPRadiusAttributes radAttr_eap2 = new EAPRadiusAttributes(79,eapMsg2.net_msg);
        
		

        radPkt.addAttribute(radAttr_name);
//        radPkt.addAttribute(radAttr_pwd);
//        radPkt.addAttribute(radAttr_ip);
//        radPkt.addAttribute(radAttr_port);
		EAPRadiusAttributes stateRadiusRecv2 = radPktRecv2.getAttributeByType(24);
		if((stateRadiusRecv2 != null) && (stateRadiusRecv2.value != null)) {
			DebugInfo.printMessage(1,"State Attribute found");
	        radPkt.addAttribute(stateRadiusRecv2);
		}
		
        radPkt.addAttribute(radAttr_auth);
        radPkt.addAttribute(radAttr_eap2);

		radAttr_auth.setMessageAuthenticator(radPkt,SharedSecret);
		radPkt.toByteArray();
		

		DebugInfo.printDump(1, radPkt.net_msg, "Radius packet");
		DebugInfo.printMessage(1,"Sending Radius packet");

		sendPacket = new DatagramPacket(radPkt.net_msg, radPkt.net_msg.length, remoteIPAddress, destination_port);
		clientSocket.send(sendPacket);

		DebugInfo.printMessage(1,"packet has been sended");


// parse received message		
		clientSocket.receive(receivePacket);
		DebugInfo.printMessage(1,"packet has been received, length: " + receivePacket.getLength());
		DebugInfo.printDump(2, receivePacket.getData(), 0, receivePacket.getLength() , "recvpkt");

		EAPRadiusHeader	radPktRecv3 = new EAPRadiusHeader();
		radPktRecv3.net_msg = new byte[receivePacket.getLength()];
		System.arraycopy(receivePacket.getData(), 0, radPktRecv3.net_msg, 0, receivePacket.getLength());
		res1 = radPktRecv3.parseNetMessage();
		DebugInfo.printMessage(1,"packet was parsed, res: " + res1);
		radPktRecv3.print();


// parse EAP received message
		EAPheader eapRecv3 = null;
		EAPRadiusAttributes eapRadiusRecv3 = radPktRecv3.getAttributeByType(79);
		if((eapRadiusRecv3 != null) && (eapRadiusRecv3.value != null)) {
			DebugInfo.printMessage(1,"EAP message found, try parse");
			eapRadiusRecv3.print("");
			if(eapRadiusRecv3.value.length > 4)
				eapRecv3 = new EAPpldBasic();
			else
				eapRecv3 = new EAPheader();
			
			eapRecv3.net_msg = new byte[eapRadiusRecv3.value.length];
			System.arraycopy(eapRadiusRecv3.value, 0, eapRecv3.net_msg, 0, eapRadiusRecv3.value.length);
			res1 = eapRecv3.parseNetMessage(); 
			DebugInfo.printMessage(1,"EAP packet was parsed, res: " + res1);
			eapRecv3.print();
		}

// close socket		
		clientSocket.close();
		DebugInfo.printMessage(1,"socket closed");
	}

	public static int ntohs(byte[] x, int pos)
	{
		int res = 0;
		if(x.length >= 2) {
				res = x[pos++] & 0xFF;
				res <<= 8;
				res |= (x[pos] & 0xFF);
		}
		return res;
	}

}

